unit UseDLL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Vcl.Menus, Vcl.Grids, Vcl.Samples.Calendar,
  Vcl.ComCtrls;

type
  Str8=String[8];
  DetailsRcd=Record
                  DateTimeM:tDateTime;
                  Combo1   :integer;      //save the three combobox itemindex
                  Combo2   :integer;
                  Combo3   :integer;
                  Lat      :str8;
                  Long     :str8;
                  LatD     :str8;
                  LongD    :str8;
                  Ht       :str8;
                  HtD      :str8;
                  BandS    :str8;
                  SunSW    :boolean;
                  RefSW    :boolean;
  End;
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit7: TEdit;
    Label7: TLabel;
    Edit8: TEdit;
    Label8: TLabel;
    Edit9: TEdit;
    Label9: TLabel;
    Timer1: TTimer;
    Button2: TButton;
    Button3: TButton;
    Edit10: TEdit;
    Label11: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Edit13: TEdit;
    Label17: TLabel;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Edit17: TEdit;
    Label21: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit23: TEdit;
    Label26: TLabel;
    Edit18: TEdit;
    Label22: TLabel;
    Edit19: TEdit;
    Label23: TLabel;
    Label27: TLabel;
    Edit22: TEdit;
    Label28: TLabel;
    Edit24: TEdit;
    Label29: TLabel;
    Edit25: TEdit;
    Label30: TLabel;
    Edit26: TEdit;
    Label31: TLabel;
    Label16: TLabel;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    DateTimePicker1: TDateTimePicker;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label32: TLabel;
    Edit27: TEdit;
    Edit28: TEdit;
    Label34: TLabel;
    Panel1: TPanel;
    Edit29: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Edit30: TEdit;
    Label39: TLabel;
    Edit31: TEdit;
    Label40: TLabel;
    Edit32: TEdit;
    Label41: TLabel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Label10: TLabel;
    Button4: TButton;
    Label33: TLabel;
    Label42: TLabel;
    Edit33: TEdit;
    Label45: TLabel;
    Label46: TLabel;
    Label44: TLabel;
    Image1: TImage;
    Label47: TLabel;
    Label48: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function  GetTimeZoneBias:TdateTime;
    procedure Help1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SaveData;
    procedure GetData;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

    //these are the declarations for the external routines in VK5DJ_sunmoon.dll
    procedure DataToDLL(Year,Month,Day,Hour,Minute,Second:word; HtASL, Latitude, Longitude:double; RefractSwitch,SunMoonSW:boolean;Band:double); StdCall; external 'VK5DJ_sunmoon.dll';
    function GetElevation:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetAzimuth:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDoppler:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetLibration:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDistance:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetAngularDiam:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetRightAsc:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetRtAscHHMMSS:str8;  stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDeclination:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDecTopo:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDXdistance(Longitude,Latitude,RemoteLong,RemoteLat:double;Dist_B:boolean):double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetPolarity:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetDB:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetGHA:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetLHA:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetLocator(Latitude,Longitude:double):str8;  stdcall; external 'VK5DJ_sunmoon.dll';
    function GetLatLong(Locator:Str8; LatOrLong:boolean):double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetVersion:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetMoonIllum:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetMoonPhase:double; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetQuarter:str8; stdcall; external 'VK5DJ_sunmoon.dll';
    function GetPhaseAngle:double; stdcall; external 'VK5DJ_sunmoon.dll';
var
  Form1: TForm1;

implementation

{$R *.dfm}
uses DateUtils,Math,HTMLhelpViewer;



Var Year,Month,Day, Hour, Minute, Second, Msec                :word;
    Latitude, HtASL, RemHtASL, Longitude, RemoteLat,RemoteLong:double;
    PolarityHome, PolarityRemote, PolarityShift               :double;
    DopplerHome, DopplerRemote                                :double;
    RefractSwitch,SunMoonSW                                   :boolean;
    Band                                                      :double;
    MoonTime                                                  :TdateTime;
    CurrentD                                                  :string;
    InputRecord                                               :DetailsRCD;

function Tform1.GetTimeZoneBias:TdateTime;                   //this routine brings in computer clock and corrects it to UTC
var
      TZoneInfo: TTimeZoneInformation;
      TimeZoneBias: longint;
      DaylightsavingSet:byte;
      UTCDateTime:TdateTime;
begin
     DaylightSavingSet:=gettimezoneinformation(Tzoneinfo);
     TimeZoneBias := TZoneInfo.Bias;
     UTCDateTime:=IncMinute(Now,TimeZoneBias);
     if DaylightSavingSet = 2  then
      begin
      UTCDateTime:=IncMinute(UTCDateTime,Tzoneinfo.Daylightbias);
      end;
     result:=UTCDateTime;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  Application.HelpFile :=CurrentD+ '\SunMoon.chm'; //chm help, must include HTMLhelpViewer in compile
  Application.HelpCommand(HELP_CONTENTS,0);
end;

procedure TForm1.Button1Click(Sender: TObject);    //this routine shows how to access the data
Var Intermediate: double;
begin
    //this call sends the data to the sunmoon engine and is essential
    DataToDLL(Year,Month,Day,Hour,Minute,Second, HtASL, Latitude, Longitude, RefractSwitch,SunMoonSW,Band);

    //now read back the information
    edit1.Text:=floattostrF(GetAzimuth,ffFixed,5,2);   //an example of how to make AZ a two dec place printout
    edit2.Text:=floattostrF(GetElevation,ffFixed,5,2); //an example of how to make EL a two dec place printout
    DopplerHome:=GetDoppler;                           //get the home to home doppler
    edit3.text:=inttostr(Round(DopplerHome));          //now print doppler home
    edit4.text:= GetRtAscHHMMSS;                       //returns RtAsc converted by RtAscToHHMMSS to hh:mm:ss
    edit5.Text:=floattostrF(GetDeclination,ffFixed,6,3);  //geocentric declination
    edit18.Text:=floattostrF(GetDecTopo,ffFixed,6,3);     //topocentric declination
    edit6.text:=floattostrF(GetDistance,ffFixed,6,0);     //this would normally not be in the loop every second
    edit7.text:=floattostrF(GetAngularDiam,ffFixed,1,2);  //this would normally not be in the loop every second
    edit16.text:=floattostrF(GetGHA,ffFixed,8,3);         //Greenwich hour angle
    edit23.text:=floattostrF(GetLHA,ffFixed,8,3);         //local hour angle
    edit19.text:=floattostr(round(GetLibration));//(Round(GetLibration));        //gets moon libration
    edit22.Text:=floattoStrF(GetMoonIllum, ffFixed,3,0)+' %'; //illumination as a percentage
    edit24.Text:=floattoStrF(GetMoonPhase,ffFixed,1,2);//moon phase as 0>0.5>1.0 with 0.5 as full moon
    edit25.Text:=GetQuarter;                           //shows the moons current quarter
    edit26.Text:=floattoStrF(GetPhaseAngle,ffFixed,6,3);//shows the phase angle

    //get additional loss due to distance and size of moon
    edit13.Text:=floattostrF(GetDB, ffFixed,1,2);                   //this would normally not be in the loop every second

    //convert lat and long in dec degrees into a locator
    edit17.text:=GetLocator(Latitude,Longitude);    //this would normally not be in the loop every second

    //convert Locator into lat and long in decimal degrees
    edit20.Text:=floattostr(GetLatLong(edit17.Text,True));   //get latitude from Locator send "true" for Lat
    edit21.Text:=floattostr(GetLatLong(edit17.Text,False));  //get longitude from Locator send "false" for Long

    //getDXdistance calculates either DX distance or bearing depending on setting of switch Dist_B
    //switch to "true" to calculate great circle distance
    Intermediate:=GetDXdistance(Longitude,Latitude,RemoteLong,RemoteLat,True);   //TRUE or FALSE to be set by program normally ("true"=distance)
    edit8.text:= floattostrF(Intermediate,ffFixed,5,0);   //used an intermediate variable to simplify code

    //switch to "false" to calculate bearing
    Intermediate:=GetDXdistance(Longitude,Latitude,RemoteLong,RemoteLat,False);   //FALSE would not normally be fixed ("false" =bearing)
    edit9.text:= floattoStrF(Intermediate,ffFixed,3,1); //used an intermediate temp variable to simplify code

    //get the H/H doppler shift
    DopplerHome:=GetDoppler;                            //note the new version of the DLL does not require a parameter for doppler

    //to extract the polarisation shift of antenna (DataToDLL must first be sent with station info before reading GetPolarity)
    PolarityHome:=GetPolarity;                          //call home polarity before racalling the routines with the DX data

    //now send the remote station data and recalculate to obtain remote data
    DataToDLL(Year,Month,Day,Hour,Minute,Second, RemHtASL, RemoteLat, RemoteLong, RefractSwitch,SunMoonSW,Band); //second time but with the remote station info
    PolarityRemote:=GetPolarity;                                                              //complements the earlier call to Getpolarity for Home
    PolarityShift:=PolarityHome-PolarityRemote;                                               //get the difference
    if PolarityShift < 0 then PolarityShift:=PolarityShift+360;                               //now adjust the quadrants
    if (PolarityShift > 90) and (PolarityShift <= 270) then PolarityShift:=PolarityShift-180;
    if (PolarityShift > 270) and (PolarityShift <= 360) then PolarityShift:=PolarityShift-360;
    edit10.Text:=inttostr(round(PolarityShift));        //print the polarity rotation needed

    //have calculated remoteDX station info with the DATAtoDLL so extract the DopplerRemote using the parameter 2
    DopplerRemote:=GetDoppler;                       // get the DX/DX doppler after Steer is called with the DX information
    edit11.text:=inttostr(round(DopplerRemote));
    edit12.text:=inttostr(round(DopplerHome/2 +DopplerRemote/2));
    edit14.text:= floattostr(GetAzimuth);               //remote az
    edit15.Text:=floattostr(GetElevation);              //remote el
    label27.Caption:='DLL version '+floattostr(GetVersion);
    label46.Caption:=datetimetostr(moontime);
end;

procedure TForm1.Button2Click(Sender: TObject);              //update 1 per second button event
begin
    Button4Click(sender);  //load initial info
    Timer1.Enabled:=true;  //turn on timer
end;

procedure TForm1.Timer1Timer(Sender: TObject);               //this is the timer event
begin
     moontime:=incsecond(Moontime,1);
     DecodeDateTime(Moontime,Year,Month,Day,Hour,Minute,Second,Msec);
     button1click(sender);
end;

procedure TForm1.Button3Click(Sender: TObject);              //pressing this button utilises the computer clock
begin
     Moontime:=GetTimeZoneBias;                              //set moontime to now from computer clock
     Timer1.Enabled:=true;
     button1click(sender);
end;


procedure TForm1.Button4Click(Sender: TObject);             //load the info and do one calculation
begin
    Timer1.enabled:=false;
    decodeDate(datetimepicker1.date,  Year, month, day);
    hour:=strtoint(combobox1.Text);
    minute:=strtoint(combobox2.Text);
    second:=strtoint(combobox3.Text);
    Moontime:=encodedatetime(Year, Month, Day, Hour, Minute, Second, 0); // Creates moontime TdateTime from line above
    Latitude:= strtofloat(edit27.text);
    Longitude:= strtofloat(edit28.text);
    HtASL:= strtofloat(edit29.text);
    RemoteLat:= strtofloat(edit30.text);
    RemoteLong:= strtofloat(edit31.text);
    RemHtASL:= strtofloat(edit32.text);
    Band:=strtofloat(edit33.text);
    If Radiogroup1.itemindex=0 then SunMoonSW:= true else SunMoonSw:=false;
    If Radiogroup2.itemindex=0 then RefractSwitch:= true else RefractSwitch:=false;
    button2.Visible:=true; button3.Visible:=true;
    label44.Visible:=true;
    label27.Visible:=true; label46.visible:=true;
    button1click(sender);
end;

Function Open(FileName: shortstring): Boolean; //see if file exists
  { Returns True if file exists; otherwise,it returns False.
    Closes the file if it exists. }
var
    f: file;
begin
    {$I-}
    AssignFile(f, FileName);
    Reset(f);
    Closefile(f);
    {$I+}
    Open:= (IOResult = 0) and (FileName <> '');
end;  { Open }

//save the input data to a file called "GetDLL.DTA" on program close

procedure Tform1.SaveData;
Var GetDLLfile :file of DetailsRcd;
    Year, Month, Day, Hour, Minute, Second: word;
begin
      decodeDate(datetimepicker1.date,Year,month,day);
      with InputRecord do      //assign values to the record
        begin
             hour  :=strtoint(combobox1.Text);
             minute:=strtoint(combobox2.Text);
             second:=strtoint(combobox3.Text);
             DateTimeM:=encodeDateTime(Year, Month, Day, Hour, Minute, Second, 0);
             combo1:=combobox1.itemindex;
             combo2:=combobox2.itemindex;
             combo3:=combobox3.itemindex;
             Lat:= edit27.text;
             Long:=edit28.text;
             LatD:=edit30.text;
             LongD:=edit31.text;
             Ht:= edit29.text;
             HtD:=edit32.text;
             BandS:=edit33.text;
             If Radiogroup1.itemindex=0 then SunSW:= true else SunSw:=false;
             If Radiogroup2.itemindex=0 then RefSw:= true else RefSw:=false;
        end;
      Assignfile(GetDLLfile, currentD+'\getDLL.dta');
      Rewrite(GetDLLfile);
      Write(GetDLLfile, InputRecord);     //now save the record
      CloseFile(GetDLLfile);
end;

//get the input data fromo a file called "GetDLL.DTA" on program open

procedure tForm1.GetData;
Var GetDLLfile :file of DetailsRcd;
    Millisec:word;
begin
    If Open(currentD+'\getDLL.dta') then  //check that file exists first
    begin
      Assignfile(GetDLLfile, currentD+'\getDLL.dta');
      Reset(GetDLLfile);
      Read(GetDLLfile, InputRecord);
      CloseFile(GetDLLfile);
      with InputRecord do
        begin
             decodedatetime(DateTimeM,Year, Month, day, hour, minute, second, millisec);
             datetimepicker1.date:=encodedate(Year, Month, Day);
             combobox1.itemindex:= combo1;
             combobox2.itemindex:= combo2;
             combobox3.itemindex:= combo3;
             edit27.text:=Lat;
             edit28.text:=Long;
             edit29.text:=Ht;
             edit30.text:=LatD;
             edit31.text:=LongD;
             edit32.text:=HtD;
             edit33.text:=Bands;
             If SunSw=true then Radiogroup1.itemindex:=0 else Radiogroup1.itemindex:=1;
             If RefSW=true then Radiogroup2.itemindex:=0 else RadioGroup2.itemindex:=1;
        end;
    end;
end;


//formcreate sets up the various conditions, these will be elsewhere in your code.

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     SaveData;
end;

//setup the initial values for the variables for this test program

procedure TForm1.FormCreate(Sender: TObject);
begin
    Timer1.enabled:=false;
    GetDir(0,CurrentD);               // get the current directory
    GetData;                          // bring in old data if it exists
end;



end.


